$if not setglobal debug $offlisting offinclude

$ontext

         XLDUMP: GAMS Spreadsheet Creation and Data Export Utility

                     (an interface to XLLINK.EXE)

Usage:

	 $LIBINCLUDE XLDUMP ident[.suffix] xlfile [worksheet [range]]


N.B.  Data transfer occurs at execution time.

This routine is different from XLEXPORT in the following ways:

(1) The target worksheet can be created "from scratch" in 
    Excel format (saved in the default format).

(2) All data and labels are written into the workbook, ordered
    by the GAMS symbol table.  There are no facilities for 
    matching data to labels within the spreadsheet.

    N.B. The ordering of row and column labels written to the
    spreadsheet is effectively random and cannot be controlled
    (it follows the GAMS program symbol table).  If a particular
    ordering is desired, do an XLDUMP first, then rearrange the
    rows/columns within the spreadsheet and subsequently use
    XLEXPORT to move data in accordance with the spreadsheet
    labels.

(3) If no worksheet is specified, the data is written to the 
    default worksheet.

$offtext

$if setglobal xl_system $goto openfile
$setglobal xl_system 'operating'
$echo %system.gstring%     >xllink.log
$echo XLLINK Activity Log >>xllink.log
$libinclude gams2txt 

$label openfile

$set newcmdfile "%gams.scrdir%xlcmd.scr"
$if not setglobal oldcmdfile $setglobal oldcmdfile ''
$if '%oldcmdfile%' == '%newcmdfile%' $goto cmdfileok
$setglobal oldcmdfile %newcmdfile%
$if declared xllink_cmd $kill xllink_cmd
file xllink_cmd / "%newcmdfile%" /;

$label cmdfileok


$set newfile '%gams.scrdir%xllink.scr'
$if not setglobal oldfile $setglobal oldfile ''
$if '%oldfile%' == '%newfile%' $goto countargs
$setglobal oldfile %newfile%
$if declared xllink_tmp $kill xllink_tmp
file xllink_tmp / %newfile% /;

$label countargs

*	Permit a blank invocation:

$if a%1 == a $exit

$hidden         Begin by checking that the parameter exists:

$if a%5 == a $goto begin
$error  XLDUMP invoked with 5 arguments? 1=%1 2=%2 3=%3 4=%4  5=%5
$error  Syntax requires at most 4 arguments.
$log    XLDUMP invoked with 5 arguments? 1=%1 2=%2 3=%3 4=%4  5=%5
$log    Syntax requires at most 4 arguments.
$abort

$label begin
$if declared %1    $goto declared
$error XLDUMP identfier %1 is not declared.
$log   XLDUMP identfier %1 is not declared.
$abort

$label declared
$if defined %1     $goto defined
$error XLDUMP identfier %1 is not defined.
$log   XLDUMP identfier %1 is not defined.
$abort

$label defined
$setlocal sheet  "%3"
$setlocal range  "%4"
$goto start

$hidden         At this point, we have the sheet specified if it is provided

$label start
$setlocal data   "%1"
$setlocal xlfile "%2"
$if exist %2.xls $setlocal xlfile "%2.xls"

$label write_flat
put xllink_tmp;
$setglobal timestamp no
$libinclude gams2txt %data%
$setglobal timestamp yes
putclose;

*	Set the dimensions:

$if dimension 0 %data% $set dimen 0
$if dimension 1 %data% $set dimen 1 
$if dimension 2 %data% $set dimen 2 
$if dimension 3 %data% $set dimen 3 
$if dimension 4 %data% $set dimen 4 
$if dimension 5 %data% $set dimen 5 
$if dimension 6 %data% $set dimen 6 
$if dimension 7 %data% $set dimen 7 
$if dimension 8 %data% $set dimen 8 
$if dimension 9 %data% $set dimen 9 
$if dimension 10 %data% $set dimen 10

putclose xllink_cmd, '%newfile%'/'%xlfile%'/'%dimen%'/'%sheet%'/'%range%'//;

$if     a%sheet%==a execute "echo --- Dumping '%data%' into workbook '%xlfile%'";
$if not a%sheet%==a execute "echo --- Dumping '%data%' into workbook '%xlfile%', sheet '%sheet%'";
execute "echo %system.incparent% XLDUMP %1 %2 %3 >>xllink.log";
if (execerror ne 0, execerror = 0);
execute 'xllink %newcmdfile% xllink.log';
if (execerror ne 0,
  display "An XLLINK execution error occured following invocation:",
          "         XLDUMP %1 %2 %3",
          "See XLLINK.LOG for an error code.";
  execute 'echo === XLLINK command file:>>xllink.log';
  execute 'copy xllink.log+%newcmdfile% xllink.log >nul';
$if setglobal abortxlerr  abort "Exiting GAMS program";
  display  "Continuing with GAMS program.";
  execerror = 0;
);

*.execute 'del %newcmdfile%';
